----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:39:03 12/02/2010 
-- Design Name: 
-- Module Name:    entprell - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use IEEE.STD_LOGIC_ARITH.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity entprell is
    Port ( eingang : in  STD_LOGIC;
			  CLK:	in	  STD_LOGIC;
           Qout : out  STD_LOGIC);
end entprell;

architecture Behavioral of entprell is
begin
process(eingang,CLK)	-- Reagiere auf Glock und den Eingang.
	variable count: integer range 0 to 5100 := 0;
	
	begin
		if CLK'EVENT and CLK='1' then	
			
			if eingang = '1' then				-- Taster gedrckt
			count := count+1;						-- Zhle die Taktflanken
				if count = 5000  then			-- Nach 1ms setze den Ausgang auf '1'
					Qout <= '1';
					count:=0;						-- Counter reset
				end if;
			end if;
			if  eingang ='0' then 				-- Taster losgelassen
				count := count+1;					-- Zhle die Taktflanken
				if count = 5000  then			-- Nach 1ms setze den Ausgang auf '0' 
					Qout <= '0';
					count:=0;						-- Counter reset
				end if;
			end if;
		end if;
end process;
end Behavioral;

